<?php // admin.php

session_start(); // startet die Session 

include('config.inc.php'); // Config.inc.php einbinden

$pfad = $_SERVER['SCRIPT_NAME'];			// aktueller Pfad zur Datei

//---------------------- Logindaten --------------------------------- //

$grafixx_name = "USERNAME";					// Loginname angeben
$grafixx_pass = "PASSWORT";					// Loginpasswort angeben

//------------------------------------------------------------------ //

// Funktion um die DB-Eintraege zu pruefen => SQL Injektions
function clean_it($dirty){ 
    
     // Auswirkungen von magic_quotes_gpc zuruecksetzen, wenn ON
    if (get_magic_quotes_gpc()) {
        $clean = mysql_real_escape_string(stripslashes(htmlspecialchars($dirty)));
    }else{
        $clean = mysql_real_escape_string(htmlspecialchars($dirty));
    }

    return $clean;
}

ob_start();	// startet den Ausgabepuffer

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title>Grafixx Umfragen</title>
<meta content="IE=EmulateIE7" http-equiv="X-UA-Compatible" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<meta content="no" http-equiv="imagetoolbar" />
<meta content="de" http-equiv="Content-Language" />
<link href="style.css" rel="stylesheet" type="text/css" />
<script type="text/javascript">
<!--

function add_input(){ // Input erstellen
	var wo = document.getElementById('wo');
	var li = document.createElement('li');
	
	var input = document.createElement('input');
		input.type = 'text';
		input.name = 'antwort[]';
		
	li.appendChild(input);		
	li.appendChild(document.createTextNode(' '));

	var button=document.createElement('input');
		button.type = 'button';
		button.className = 'button small';
		button.onclick=function(){delete_input(this);};
		button.value = 'loeschen';

	li.appendChild(button);
	wo.appendChild(li);
}

function delete_input(feld){ // Input loeschen
	feld.parentNode.parentNode.removeChild(feld.parentNode);
}

//-->
</script>
</head>

<body>

<div id="ram">
	<div id="header">
		<h1>Grafixx Umfragen</h1>
	</div>
	<div id="content">
		<?php

if(!isset($_SESSION['login'])) { // wenn keine Session vorhanden

    if(isset($_POST['submit_login'])) { // wenn supbit gedrueckt

        $login_name = strip_tags($_POST['log_user']); // Variable definieren
        $login_pass = strip_tags($_POST['log_pass']); // Variable definieren

        if(empty($login_name) OR empty($login_pass)) { // Pruefen ob Username angegeben wurde
            $message .= 'Bitte geben Sie ihren Usernamen und das Passwort ein ... <br />'; $error = "1";
         }     
     
         if($login_name != $grafixx_name OR $login_pass != $grafixx_pass){  // Angaben auf Korrektheit pruefen
            $message .= 'Zugriff verweigert ... <br />'; $error = "1";
         }
    
        if($error != "1"){ // Wenn kein Fehler war
        
            // session handle-----------------------------
            $_SESSION['login'] = $_SERVER['REMOTE_ADDR']; // Session setzen

            header("Location: $pfad"); // Weiterleiten
        }
    
        if($error == "1"){  // Fehlermeldung ausgeben wenn vorhanden
            echo "<div class=\"error\"><h2>Error ...</h2>\n <p>$message</p></div>\n";
        }

    }
?>
		<form action="" method="post">
			<fieldset>
			<legend><span class="color">Grafixx</span> Login</legend>
			<label>Name</label> <input name="log_user" type="text" /><br />
			<label>Passwort</label> <input name="log_pass" type="password" />
			<br />
			<br />
			<input class="button" name="submit_login" type="submit" value="Login" />
			</fieldset>
		</form>
		<?php    
} // close isset Session login
// ----------------------------------------------- Ende Login ------------------------------------- //

if(isset($_SESSION['login'])){              // Sofern Session vorhanden ... 

$action = clean_it($_GET['action']); 		// Variable definieren

// ----------------------------------------------------------------------
// LOGOUT
// ----------------------------------------------------------------------
if($action == 'logout'){ 
	session_unset();			// Sessionvariable loeschen	
	session_destroy();			// Session zerstoeren

	header("Location: $pfad");	// Weiterleitung => Login
}

// ----------------------------------------------------------------------
// Umfrage erstellen/bearbeiten
// ----------------------------------------------------------------------
if($action == 'new'){

	$id = clean_it($_GET['id']);		// Variable definieren

	if (isset($_POST['submit'])) {
	
		$frage = clean_it($_POST['frage']); 
		$status = clean_it($_POST['status']); 
	
		if(empty($frage) || empty($status) || empty($_POST['antwort'])){ // Pruefen ob alles angegeben
			echo "<div class=\"error\"><h2>Error...</h2><p>Bitte danke alle Felder ausfuellen!</p></div>\n";
	
		}else{ // Sofern alles angegeben wurde
			
			// Frage in DB eintragen
			$umfrage = mysql_query("INSERT INTO grafixx_poll (frage, status, date) VALUES ('$frage','$status', now() )");
			$poll_id = mysql_insert_id(); // POLL ID bestimmen
			
			if($umfrage){ // sofern frage in DB eingetragen => Antworten in DB schreiben
		        foreach($_POST['antwort'] as $antwort){ // antworten eintragen
					$eintragen = mysql_query("INSERT INTO grafixx_antworten (poll_id, antwort) VALUES ('$poll_id','$antwort')");
				}
			}	
				
			if($umfrage AND $eintragen){ // Sofern Eintrag geklappt hat
			
				header("Location: $pfad");	// Weiterleitung
				
			}else{ // Wenn Eintrag nicht geklappt hat => Fehlermeldung
				echo "<div class=\"error\"><h2>Error ...</h2>\n";
				echo "<p>Der Eintrag war leider nicht erfolgreich! ".mysql_error()."</p>\n</div>\n";
			}

		} // close alles angegeben 
	}// close submit

// Formular ausgeben
?>
		<form action="" method="post" name="form">
			<fieldset>
			<legend>Umfrage erstellen</legend>
			<label>Frage</label> <input class="long" name="frage" type="text" />
			<br />
			<label>Antworten</label>
			<ol id="wo">
				<li><input name="antwort[]" type="text" />
				<input class="button small" onclick="delete_input(this);" type="button" value="loeschen" /></li>
				<li><input name="antwort[]" type="text" />
				<input class="button small" onclick="delete_input(this);" type="button" value="loeschen" /></li>
			</ol>
			<input class="button" onclick="add_input();" type="button" value="Antwort hinzufuegen" />
			<br />
			<br />
			<label class="go_left">Status:</label>
			<input class="radio" name="status" type="radio" value="aktiv" /> 
			aktiv
			<input class="radio" name="status" type="radio" value="inaktiv" /> 
			inaktiv
			<br />
			<br class="clear_left" />
			<input class="button" name="submit" type="submit" value="Umfrage erstellen" />
			</fieldset>
		</form>
<?php
} // close action=new


// ----------------------------------------------------------------------
// Umfrage Bearbeiten
// ----------------------------------------------------------------------
if($action == 'edit'){

	$id = clean_it($_GET['id']); // Variable definieren

	if(isset($_GET['id'])){ // Sofern ID uebergeben wurde
	
		// DB Abfragen
		$abfrage = mysql_query("SELECT frage, status FROM grafixx_poll WHERE id = '$id'");
		$row = mysql_fetch_object($abfrage);
		
		$select = mysql_query("SELECT id, antwort FROM grafixx_antworten WHERE poll_id = '$id'");
		$total = mysql_num_rows($select);
	}
	
	if(isset($_POST['submit'])){ // sofern submit gedrueckt wurde

		$frage = clean_it($_POST['frage']); 	// variable definieren
		$status = clean_it($_POST['status']); 	// variable definieren

		if(empty($frage) OR (empty($_POST['antwort']) AND empty($_POST['antworten']))){ // Pruefen ob alles angegeben
			echo "<div class=\"error\"><h2>Error...</h2><p>Bitte danke alle Felder ausfuellen!</p></div>\n";
	
		}else{ // Sofern alles angegeben wurde
			
			// Frage in DB eintragen
			$umfrage = mysql_query("UPDATE grafixx_poll SET frage = '$frage', status = '$status' WHERE id = '$id' ");
			
			if($umfrage){ // sofern frage in DB eingetragen => Antworten in DB schreiben/updaten
				
				if(!empty($_POST['antworten'])){ // Sofern eine neue Antwort dazu gekommen ist
					// Antworten bearbeiten
					foreach($_POST['antworten'] as $antworten){
						// $a_id = id der zu bearbeitenden antwort
						// $antwort = value => neue antwort
				   		foreach ($antworten as $a_id => $antwort){
				   		// DB updaten
						$update = mysql_query("UPDATE grafixx_antworten SET antwort = '$antwort' WHERE id = '$a_id' ");
				   		}
					}  
				}
				
				if(!empty($_POST['antwort'])){ // Sofern eine neue Antwort dazu gekommen ist
			        foreach($_POST['antwort'] as $new_antwort){ // antworten eintragen
						$eintragen = mysql_query("INSERT INTO grafixx_antworten (poll_id, antwort) VALUES ('$id','$new_antwort')");
					}
				}// close !empty	
							
			}	
			
			if($umfrage AND $update OR $eintragen){ // Sofern Eintrag geklappt hat
			
				header("Location: $pfad");	// Weiterleitung
				
			}else{ // Wenn Eintrag nicht geklappt hat => Fehlermeldung
				echo "<div class=\"error\"><h2>Error ...</h2>\n";
				echo "<p>Der Eintrag war leider nicht erfolgreich! ".mysql_error()."</p>\n</div>\n";
			}

		} // close alles angegeben 
	
	}// close submit
      
    // Antwort loeschen  
	if(isset($_POST['delete'])){ 
		
		foreach($_POST['delete'] as $loeschen){
			foreach ($loeschen as $del_id => $v){// zu loeschende ID ermitteln
			
		   		// DB => Antwort loeschen
				$delete = mysql_query("DELETE FROM grafixx_antworten WHERE id = '$del_id' ");
				
				// DB => IP zu der Antwort loeschen
				$del_ip = mysql_query("DELETE FROM grafixx_poll_ip WHERE antwort_id = '$del_id' ");
		   }
		}  
		
		header("Location: ".$pfad."?action=edit&id=".$id ."");	// Weiterleitung 

	} 
// Formular ausgeben
?>
		<form action="" method="post">
			<fieldset>
			<legend>Umfrage bearbeiten</legend>
			<label>Frage</label> <input class="long" name="frage" type="text" value="<?php echo $row->frage; ?>"/>
			<br />
			<label>Antworten</label>
			<ol id="wo">
			<?php 
				while($rows = mysql_fetch_object($select)){
					// vorhadene Antworten ausgeben
					echo "<li><input name=\"antworten[][".$rows->id."]\" type=\"text\" value=\"".$rows->antwort."\" />\n";
					echo "<input class=\"button small\" type=\"submit\" value=\"loeschen\" name=\"delete[][".$rows->id."]\" /></li>\n";
				}
			?>
			</ol>
			<input class="button" onclick="add_input();" type="button" value="Antwort hinzufuegen" />
			<br />
			<br />
			<label class="go_left">Status:</label>
			<input class="radio" name="status" type="radio" value="aktiv" <?php if($row->status == 'aktiv'){ echo "checked=\"checked\""; } ?>/> 
			aktiv
			<input class="radio" name="status" type="radio" value="inaktiv" <?php if($row->status == 'inaktiv'){ echo "checked=\"checked\""; } ?>/> 
			inaktiv
			<br />
			<br class="clear_left" />
			<input class="button" name="submit" type="submit" value="Speichern" />
			</fieldset>
		</form>
<?php
} // close action=edit

// ----------------------------------------------------------------------
// Umfrage Loeschen
// ----------------------------------------------------------------------
if($action == 'loeschen'){

	$id = clean_it($_GET['id']);		// Variable definieren
	$mode = clean_it($_GET['mode']);	// Variable definieren
	
  if(!isset($_GET['mode'])){ // Zur Sicherheit lieber noch mal nachfragen
  
  	echo "<div class=\"error\"><h2>Wirklich ...</h2>\n";
  	echo "<p>Bist du sicher dass du die Umfrage loeschen moechtest?</p> \n";
	echo "<p><a href=\"".$pfad."?action=loeschen&amp;mode=del&id=$id\" class=\"button\">&nbsp;&nbsp;Ja&nbsp;&nbsp;</a>";
	echo "&nbsp;&nbsp;<a href=\"".$pfad."\" class=\"button\">&nbsp;&nbsp;Nein&nbsp;&nbsp;</a></p>\n </div>";

  }else{	  
  
		// Umfrage loeschen
		$delete = mysql_query("DELETE FROM grafixx_poll WHERE id='$id'");

		// Umfrage Optionen loeschen
		$del_a  = mysql_query("DELETE FROM grafixx_antworten WHERE poll_id='$id'");

		// IP's der Umfrage loeschen
		$del_ip  = mysql_query("DELETE FROM grafixx_poll_ip WHERE poll_id='$id'");
		
		if($delete AND $del_a AND $del_ip){ // Wenn Loeschung nicht erfolgt
		
			header("Location: $pfad");	// Weiterleitung 
			
		}else{ // Wenn Eintrag nicht geloescht wurde => Fehlermeldung
				echo "<div class=\"error\"><h2>Error ...</h2>\n";
				echo "<p>Der Eintrag konnte leider nicht geloescht werden! ".mysql_error()."</p>\n</div>\n";
		}
		
  } // close mode
  
} // close action = loeschen

// ----------------------------------------------------------------------
// Umfragen auflisten
// ----------------------------------------------------------------------
if(!isset($_GET['action'])){ // Sofern keine Aktion => umfragen Anzeigen

	echo "<h2>Umfragen</h2>\n";

	// DB-Abfrage => Umfragen
	$abfrage = mysql_query("SELECT id, frage, DATE_FORMAT(date, '%d.%m.%Y') AS datum, status FROM grafixx_poll ORDER BY id DESC");
	$total = mysql_num_rows($abfrage); // Anzahl umfragen
	
	// Umfragen ausgeben
	echo "<ul class=\"list\">\n";
		
	if($total > 0){ // Pruefen ob umfragen vorhanden sind
		while($row = mysql_fetch_object($abfrage)){ 
			echo "<li><div class=\"right\">\n
					<a href=\"".$pfad."?action=edit&amp;id=".$row->id."\">Bearbeiten</a>\n  
					<a href=\"".$pfad."?action=loeschen&amp;id=".$row->id."\">[x]</a>\n</div>\n";
			echo "<strong>".$row->id.".</strong> ".$row->frage."<br />\n ";
			echo "<small>".$row->datum." » <a href=\"".$pfad."?action=edit&amp;id=".$row->id."\">".$row->status."</a> </small></li>\n";
		}
	}else{ // Keine Umfragen vorhanden
		echo "<li>Derzeit sind keine Umfragen vorhanden ...</li>";
	}// close umfragen vorhanden
	
	echo "</ul>\n";
} // close umfragen anzeigen	
?>
</div>
	<div id="sidebar">
		<h2>Welcome <?php echo $grafixx_name; ?><small><a href="?action=logout">
		Logout</a></small></h2>
		<p><a class="the_button" href="<?php echo $pfad; ?>">Umfragen</a>
		<a class="the_button" href="<?php echo $pfad; ?>?action=new">Umfrage 
		erstellen</a></p>
	</div>
<?php 
} // close login

ob_end_flush(); // leert/beendet den Ausgabepuffer

?>
	<div id="footer">
		<p class="right">Valid
		<a href="http://validator.w3.org/check/referer" title="This page validates as XHTML 1.0 Transitional">
		<abbr title="eXtensible HyperText Markup Language">XHTML</abbr></a> | 
		Valid
		<a href="http://jigsaw.w3.org/css-validator/check/referer" title="CSS ist valide!">
		<abbr title="Cascading Style Sheets">CSS</abbr></a>&nbsp;&nbsp; </p>
		<p><a href="http://unnecessary.de">Grafixx Umfragen</a> ·
		<a href="http://alice-grafixx.de">Alice-Grafixx.de</a></p>
	</div>
</div>

</body>

</html>